Subject: Re: [PATCH] status: teach "status --short" to respect "--show-stash"

From: "Eric N. Vander Weele" <[email-masked]>
Date: Thu, 7 Nov 2019 18:31:41 +0800

On Wed, Nov 06, 2019 at 11:33:42AM +0900, Junio C Hamano wrote:
> "Eric N. Vander Weele" <[email-masked]> writes:
> 
> > Enable printing the entries currently stashed away in the short format.
> > This prints the stash information after the path status to be symmetric
> > with "status --long --show-stash".
> >
> > Signed-off-by: Eric N. Vander Weele <[email-masked]>
> > ---
> >  Documentation/git-status.txt |  4 ++++
> >  wt-status.c                  | 17 +++++++++++++++++
> >  2 files changed, 21 insertions(+)
> >
> > diff --git a/Documentation/git-status.txt b/Documentation/git-status.txt
> > index 7731b45f07..c1afc3282c 100644
> > --- a/Documentation/git-status.txt
> > +++ b/Documentation/git-status.txt
> > @@ -244,6 +244,10 @@ If -b is used the short-format status is preceded by a line
> >  
> >      ## branchname tracking info
> >  
> > +If --show-stash is used the short-format status is followed by a line
> > +
> > +    ## stash: <n> (entry|entries)
> > +
> 
> Hmmmm.  Would readers misinterpret we are talking about a branch
> whose name is stash something?  I am not suggesting to change ##
> introducer to some random letters, which would break scripts even
> worse.

I could see where readers may misinterpret this as a branch name.  I
struggled coming up with something short while not being confusing and
thought the presence ':' followed by a space would be clear enough.

> Doesn't the Porcelain Format v1 call the same codepath as
> shortstatus?  We promise that its output never changes to support
> existing scripts, but now they will start seeing "## stash:" that
> they do not understand and barf?

I wasn't aware of the Porcelain formats in detail when originally
creating the patch - oops!  Naively I was following the same behavior as
'--branch' in the shortstatus code path.

Diving into this further, the Porcelain Format v1 does call the same
code path as shortstatus.  I see there is some handling in
builtin/commit.c for tweaking the behavior of the branch being showed.

The documentation indicates that the behavior never changes between Git
versions or based on user configuration.  'git status --porcelain=1'
will react to '--branch' but not when 'status.branch' is set to 'true',
which is congruent with the documentation.

> Isn't this information available to scripts that want to read from
> porcelain v2 output format (which is meant to be extensible by
> allowing easy-to-parse optional headers, which this stash thing
> exactly is).

It is not available in Porcelain Format v2... yet :).

I'm happy making '--show-stash' congruent with '--branch' in v1', which
is would be in line with documented behavior, displaying something in
v2 only, or both.  Let me know how you would like to proceed and I'll
rework the patch accordingly.